/*
    CRC.
  ,  
  -   
 . . , 2001
  ,   
  -     
E-mail: super-m@narod.ru
Web: super-m.narod.ru
*/

#include <windows.h>
#include "crc.h"
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <io.h>


#define NN 2
#define NArgv 10

/*******************  Global Variables ********************/

HANDLE ghInstance;
char *cmdkey[NN];
int argc;
char *argv[NArgv];
bool Done=false;
int TheRet;
int NumFiles=0;
char *mask_path;
bool showVInfo=true, scrnOut=true, Names=true, showHelp=false;
//mask buffer:
char *mask_buffer;
int MaskBufferSize=0, MaskPos=0;
enum masktypes
{
  MT_XOR,
  MT_OR,
  MT_AND
};
int mask_type=MT_XOR;
HWND hwndMaskInfo;


/*********************  Prototypes  ***********************/
void initkeys(void);
int searchkey(char *stroka);
void FormSwitches(char *lpszCmdLine);
void AllocArgv(void);
void DeAllocArgvEtc(void);
bool LoadBitMask(char *f_path);

LRESULT WINAPI MainWndProc( HWND, UINT, WPARAM, LPARAM );
//LRESULT WINAPI AboutDlgProc( HWND, UINT, WPARAM, LPARAM );


void initkeys(void) //   
{
 cmdkey[0]="-or";
 cmdkey[1]="-and";
 return;
}//end initkeys

int searchkey(char *stroka)
{
 //char *s;
 bool fnd=false;
 int i=-1;
 while (!fnd && (i<NN)) // 
 {
  i++;
  //s=cmdkey[i];
  fnd=(lstrcmp(cmdkey[i],stroka)==0);
 }//end while
 if (!fnd) i=-1;
 return i;
}//end searchkey

void FormSwitches(char *lpszCmdLine)
{
  int i, j, pos=0, prevpos=0, len;
  bool IsSpace, WasSpace=false;
  argc=1;
  len = lstrlen(lpszCmdLine);
  if (len==0) return;
  while ((pos<=len) && (argc<NArgv-1))
  {
   IsSpace = (pos==len);
   if (! IsSpace) IsSpace=(lpszCmdLine[pos]==' ');
   if (IsSpace && (! WasSpace))
   {
    i=prevpos; j=0;
    while (i<pos)
    {
     argv[argc][j]=lpszCmdLine[i];
     i++; j++;
    }//end while
    argv[argc][j]=0;
    argc++;
   }//end if
   if (WasSpace && (! IsSpace)) prevpos=pos;
   WasSpace=IsSpace;
   pos++;
  }//end while
}//end FormSwitches

void AllocArgv(void)
{
  int i;
  //argv = new char* [NArgv];
  for (i=0; i<NArgv; i++) argv[i] = new char [256];
}//end AllocArgv

void DeAllocArgvEtc(void)
{
  int i;
  for (i=0; i<NArgv; i++) delete [] argv[i];
  if (MaskBufferSize>0)
   delete [] mask_buffer;
}//end DeAllocArgvEtc

bool LoadBitMask(char *f_path)
{
  FILE *in;
  bool ok;
  int fh, fsz;
  in = fopen(f_path, "rb");
  ok = (in!=NULL);
  if (ok)
  {
    fh=fileno(in);
    fsz=(int)filelength(fh);
    if (fsz<0x8000)
    {
      MaskBufferSize=fsz;
    }
    else
    {
      ok = (fsz>0);
      if (ok)
        MaskBufferSize=0x8000;
    }
    if (ok)
    {
      mask_buffer=new char [MaskBufferSize];
      fseek(in, 0, 0);
      fread(mask_buffer, 1, MaskBufferSize, in);
    }
    fclose(in);
  }
  return ok;
}//end LoadBitMask

///********************************************************************
///*  Function: int PASCAL WinMain(HINSTANCE, HINSTANCE, LPSTR, int)    *
///*                                                                    *
///*   Purpose: Initializes Application                                 *

///*                                                                    *
///*  Comments: Register window class, create and display the main      *
///*            window, and enter message loop.                         *
///********************************************************************/

int PASCAL WinMain( HINSTANCE hInstance,
    HINSTANCE hPrevInstance,

    LPSTR lpszCmdLine,
    int nCmdShow )
{
   WNDCLASS wc;
   MSG msg;
   HWND hWnd;
   int i;
   char *mask_msg=" ";
   AllocArgv();
   FormSwitches(lpszCmdLine);
   initkeys();

   if( !hPrevInstance )
   {
      wc.lpszClassName = "CrcAppClass";
      wc.lpfnWndProc = MainWndProc;
      wc.style = CS_OWNDC;
      wc.hInstance = hInstance;
      wc.hIcon = LoadIcon( hInstance, MAKEINTRESOURCE(IDI_WINFCOMPICON) );
      wc.hCursor = LoadCursor( hInstance, MAKEINTRESOURCE(IDC_WINFCOMPCURSOR) );
      wc.hbrBackground = (HBRUSH)( COLOR_BTNFACE+1 );
      wc.lpszMenuName = NULL;

      wc.cbClsExtra = 0;
      wc.cbWndExtra = 0;

      RegisterClass( &wc );
   }

   ghInstance = hInstance;

   hWnd = CreateWindow( "CrcAppClass",
      " CRC",
      WS_OVERLAPPED|WS_CAPTION|WS_SYSMENU|WS_MINIMIZEBOX,
      0,
      0,
      300,
      300,
      NULL,
      NULL,
      hInstance,
      NULL
   );
   ShowWindow( hWnd, nCmdShow );
   
   i=1;
   while (i<argc)
   {
     switch (searchkey(argv[i]))
     {
     case 0: mask_type=MT_OR; break;
     case 1: mask_type=MT_AND; break;
     default:
       NumFiles++;
       mask_path=argv[i];
     }
     i++;
   }
   if (NumFiles>0)
   {
     if (! LoadBitMask(mask_path))
       MessageBox(hWnd, "   ", "CRC : ",
         MB_OK | MB_ICONERROR);
   }
   if (MaskBufferSize>0)
     switch(mask_type)
     {
     case MT_XOR: mask_msg=" XOR"; break;
     case MT_OR: mask_msg=" OR"; break;
     case MT_AND: mask_msg=" AND"; break;
     }
   SetWindowText(hwndMaskInfo, mask_msg);

   while( GetMessage( &msg, NULL, 0, 0 ) ) {
      TranslateMessage( &msg );

      DispatchMessage( &msg );
   }
   DeAllocArgvEtc();

   return msg.wParam;
}

///********************************************************************
///* Function: LRESULT CALLBACK MainWndProc(HWND, UINT, WPARAM, LPARAM) *
///*                                                                    *
///*  Purpose: Processes Application Messages                           *
///*                                                                    *
///* Comments: The following messages are processed                     *

///*                                                                    *
///*           WM_PAINT                                                 *
///*           WM_COMMAND                                               *
///*           WM_DESTROY                                               *
///*                                                                    *
///*                                                                    *
///********************************************************************/

LRESULT CALLBACK MainWndProc( HWND hWnd, UINT msg, WPARAM wParam,
   LPARAM lParam )
{
   PAINTSTRUCT ps;
   HDC hDC;
   static HWND hwndEdit;
   static HWND hwndStatic1, hwndStatic2;
   static HWND hwndButtonDo, hwndButtonInfo;
   WORD wNotifyCode, wID;
   signed char buffer[1024], chr;
   unsigned char /* *ubuffer, */ uchr;
   int bufsize;
   unsigned long ulCRC=0;
   signed long lCRC=0;
   unsigned short usCRC=0;
   signed short sCRC=0;
   char buf[1024]; //buffer for numbers
   wNotifyCode = HIWORD(wParam); // notification code
   wID = LOWORD(wParam);

   switch( msg ) {

//       WM_COMMAND:

      case WM_CREATE:
         hwndEdit = CreateWindow(
                "EDIT",     /* predefined class                  */
                NULL,       /* no window title                   */
                WS_BORDER | WS_CHILD | WS_VISIBLE | ES_LEFT | ES_AUTOHSCROLL,
                10, 40, 200, 30, /* set size     */
                hWnd,       /* parent window                     */
                (HMENU) ID_EDITCHILD, /* edit control ID         */
                (HINSTANCE) GetWindowLong(hWnd, GWL_HINSTANCE),
                NULL);                /* pointer not needed      */
         hwndStatic1 = CreateWindow(
                "STATIC",     /* predefined class                  */
                ":",       /*  window title                   */
                WS_CHILD | WS_VISIBLE | SS_LEFT,
                10, 10, 200, 30, /* set size     */
                hWnd,       /* parent window                     */
                (HMENU) ID_STATIC1, /* edit control ID         */
                (HINSTANCE) GetWindowLong(hWnd, GWL_HINSTANCE),
                NULL);                /* pointer not needed      */
         hwndStatic2 = CreateWindow(
                "STATIC",     /* predefined class                  */
                "  ",       /*  window title    */
                WS_CHILD | WS_VISIBLE | SS_LEFT,
                10, 120, 200, 100, /* set size     */
                hWnd,       /* parent window                     */
                (HMENU) ID_STATIC2, /* edit control ID         */
                (HINSTANCE) GetWindowLong(hWnd, GWL_HINSTANCE),
                NULL);                /* pointer not needed      */
         hwndButtonDo = CreateWindow(
                "BUTTON",     /* predefined class                  */
                "",       /*  window title    */
                WS_BORDER | WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON |
                BS_CENTER | BS_VCENTER,
                120, 80, 90, 30, /* set size     */
                hWnd,       /* parent window                     */
                (HMENU) ID_BUTTON1, /* edit control ID         */
                (HINSTANCE) GetWindowLong(hWnd, GWL_HINSTANCE),
                NULL);                /* pointer not needed      */
         hwndButtonInfo = CreateWindow(
                "BUTTON",     /* predefined class                  */
                " ",       /*  window title    */
                WS_BORDER | WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON |
                BS_CENTER | BS_VCENTER,
                10, 80, 90, 30, /* set size     */
                hWnd,       /* parent window                     */
                (HMENU) ID_BUTTON2, /* edit control ID         */
                (HINSTANCE) GetWindowLong(hWnd, GWL_HINSTANCE),
                NULL);                /* pointer not needed      */
         hwndMaskInfo = CreateWindow(
                "STATIC",     /* predefined class                  */
                NULL,       /*  window title    */
                WS_CHILD | WS_VISIBLE | SS_LEFT,
                10, 250, 200, 30, /* set size     */
                hWnd,       /* parent window                     */
                (HMENU) ID_STATIC2, /* edit control ID         */
                (HINSTANCE) GetWindowLong(hWnd, GWL_HINSTANCE),
                NULL);
         break;
//     WM_COMMAND:

      case WM_COMMAND:
         if (wNotifyCode==BN_CLICKED)
         {
           switch( wID )
           {
            case ID_BUTTON1:
               /* -!*/
               GetWindowText(hwndEdit, buffer, 1024);
               bufsize = strlen(buffer);
               //ubuffer = buffer;
               for (int i=0; i<bufsize; i++)
               {
                 /*lCRC += buffer[i];
                 sCRC += buffer[i];
                 ulCRC += ubuffer[i];
                 usCRC += ubuffer[i];*/
                 if (MaskBufferSize>0)
                 {
                   switch (mask_type)
                   {
                     case MT_XOR: chr = buffer[i] ^ mask_buffer[MaskPos]; break;
                     case MT_OR: chr = buffer[i] | mask_buffer[MaskPos]; break;
                     case MT_AND: chr = buffer[i] & mask_buffer[MaskPos]; break;
                   }
                 }
                 else chr = buffer[i];
                 uchr = chr;
                 lCRC += chr;
                 sCRC += chr;
                 ulCRC += uchr;
                 usCRC += uchr;
                 MaskPos++;
                 if (MaskPos>=MaskBufferSize) MaskPos=0;
               }//end for
               strcpy(buffer, " :\n16-   = ");
               itoa(sCRC, buf, 10);
               strcat(buffer, buf);
               strcat(buffer, "\n16-   = ");
               ultoa((unsigned long)usCRC, buf, 10);
               strcat(buffer, buf);
               strcat(buffer, "\n32-   = ");
               ltoa(lCRC, buf, 10);
               strcat(buffer, buf);
               strcat(buffer, "\n32-   = ");
               ultoa(ulCRC, buf, 10);
               strcat(buffer, buf);
               if (bufsize>0)
                 SetWindowText(hwndStatic2, buffer);
               else
                 SetWindowText(hwndStatic2, "  ,   !");
            break;
            case ID_BUTTON2:
               MessageBox( hWnd,
                 "  \n"
                 " .\n 0.2  "__DATE__"\n"
                 "***    ! ***\n"
                 "  . . \n"
                 "E-mail: super-m@narod.ru\n"
                 ": super-m.narod.ru",
                 "  CRC",
                 MB_OK | MB_ICONASTERISK );
            break;
           }//end switch
         }//end if
      break;


//     WM_DESTROY: PostQuitMessage() is called

      case WM_DESTROY:
         PostQuitMessage( 0 );
         break;

//     Let the default window proc handle all other messages

      default:
         return( DefWindowProc( hWnd, msg, wParam, lParam ));

   }

   return 0;
}